// -*- Java -*-

// DebugInfo.java (13.5. 2003)

import java.lang.*;
import java.io.*;

import java.util.*;
import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;

public class DebugInfo extends HttpServlet {

    protected void service(HttpServletRequest req, HttpServletResponse resp)
	throws ServletException, IOException {
	resp.setContentType("text/html");
	resp.setBufferSize(8192);
	PrintWriter out = resp.getWriter();

	out.println("<!DOCTYPE " +
		    "HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">" +
		    "<html>" +
		    "<head><title>" +
		    getClass().getName() +
		    "</title></head>" +
		    "<body>" +
		    "<h1>DebugInfo</h1>" +
		    "<pre>");

	// general

	out.println("\nGENERAL\n" +
		    "\nContext Path : " + req.getContextPath() +
		    "\nServlet Path : " + req.getServletPath() +
		    "\nUser         : " + req.getRemoteUser() +
		    "\nPrincipal    : " + req.getUserPrincipal() +
		    "\nRole drdcal  : " + req.isUserInRole("drdcal") +
		    "\nRole xxx     : " + req.isUserInRole("xxx"));

	// context attrs

	for (Enumeration e = getServletContext().getAttributeNames();
	     e.hasMoreElements(); ) {
	    Object elem = e.nextElement();
	    out.println(elem + " : " +
			getServletContext().getAttribute((String) elem));
	}

	// session

	out.println("\nSESSION\n" +
		    "Session ID : " + req.getSession().getId());
	for (Enumeration e = req.getSession().getAttributeNames();
	     e.hasMoreElements(); ) {
	    Object elem = e.nextElement();
	    out.println(elem + " : " +
			req.getSession().getAttribute((String) elem));
	}

	// db

	ArrayList tables = null;
	try {
	    Connection con =
		(Connection) getServletContext().getAttribute("dbcon");
	    String sqlQuery = "show tables";
	    Statement sql = con.createStatement();
	    ResultSet res = sql.executeQuery(sqlQuery);
	    tables = new ArrayList();
	    while (res.next()) {
		tables.add(res.getString(1));
	    }
	}
	catch (Exception err) {
	    err.printStackTrace();
	}
	out.println("\nDATABASE\n" +
		    "tables in selected db : " +
		    (tables == null ? "db error" : tables.toString()));

	out.println("</pre></body></html>");
	out.close();
    }

    public String getServletInfo() {
        return "The DebugInfo servlet provides some debugging information.";
    }

};
