// -*- Java -*-

// DatabaseConnectionManager.java (11.5. 2003)

package drdcal;

import java.lang.*;
import java.io.*;

import javax.servlet.*;

import java.sql.*;
import java.util.*;

/**
 * <p>Searches for a running MySQL server.
 *
 * <p>Tests all hosts in the {@link #dburi} array;
 *
 */

public class  DatabaseConnectionManager implements ServletContextListener {

    private static final String[] dburi = new String[3];

    static {
	int i = 0;

	dburi[i++] = "";

	dburi[i++] = "";

	dburi[i++] = "";
    }

    public void contextInitialized(ServletContextEvent sce) {
	try {
	    Class.forName("com.mysql.jdbc.Driver").newInstance();
	    Connection con = null;
	    for (int i = 0; i < dburi.length; ++i) {
		StringBuffer msg = new StringBuffer(1024);
		msg.append("Trying db -- " + dburi[i]);
		try {
		    con = DriverManager.getConnection(dburi[i]);
		    msg.append(" -- ok");
		    System.err.println(msg);
		    break;
		}
		catch (SQLException err) {
		    //err.printStackTrace();
		    msg.append(" -- cannot connect");
		    System.err.println(msg);
		}
	    }
	    if (con == null) {
		System.err.println("DatabaseConnectionManager: " +
				   "Cannot connect to database " +
				   "[driver ok, provide correct params]");
	    }
	    else {
		sce.getServletContext().setAttribute("dbcon", con);
		System.err.println("DatabaseConnectionManager: init ok");
	    }
	}
	catch (ClassNotFoundException err) {
	    err.printStackTrace();
	}
	catch (InstantiationException err) {
	    err.printStackTrace();
	}
	catch (IllegalAccessException err) {
	    err.printStackTrace();
	}
    }
    
    public void contextDestroyed(ServletContextEvent sce) {
	try {
	    Object con = sce.getServletContext().getAttribute("dbcon");
	    if (con != null && con instanceof Connection) {
		((Connection) con).close();
		sce.getServletContext().removeAttribute("dbcon");
		System.err.println("DatabaseConnectionManager: destroy ok");
	    }
	}
	catch (Exception err) {
	    err.printStackTrace();
	}
    }

};
