// -*- Java -*-

// Email.java (11.5. 2003)

package drdcal;

import java.lang.*;
import java.io.*;

import java.util.*;

import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;

public class Email {

    private Session emailSession;

    public Email(String smtpHost) {
	Properties props = new Properties();
	props.put("mail.smtp.host", smtpHost);
	emailSession = Session.getDefaultInstance(props, null);	
    }

    public void send(String from, String to, String text) {
	try {
	    MimeMessage msg = new MimeMessage(emailSession);
	    msg.setFrom(new InternetAddress(from));
	    InternetAddress[] address = { new InternetAddress(to) };
	    msg.setRecipients(Message.RecipientType.TO, address);
	    msg.setSubject("DrD Calendar Email Service");
	    msg.setSentDate(new Date());
	    MimeBodyPart mbp1 = new MimeBodyPart();
	    mbp1.setText(text);
	    Multipart mp = new MimeMultipart();
	    mp.addBodyPart(mbp1);
	    msg.setContent(mp);
	    Transport.send(msg);
	}
	catch (MessagingException mex) {
	    mex.printStackTrace();
	}
    }

    public void send(String to, String text) {
	//send("automatic_message@without.from.attribute", to, text);
	send("xslom03@vse.cz", to, text);
    }

    public void send (Collection col, String text) {
	Iterator i = col.iterator();
	while (i.hasNext()) {
	    String email = (String) i.next();
	    send(email, text);
	}
    }

};
