// -*- Java -*-

// EmailManager.java (8.5. 2003)

package drdcal;

import java.lang.*;
import java.io.*;

import javax.servlet.*;

import java.sql.*;
import java.util.*;
import java.net.*;

/**
 * <p>Searches for a running smtp server.
 *
 * <p>Tests all hosts in the {@link #smtpHosts} array;
 *
 */

public class  EmailManager implements ServletContextListener {

    private static int smtpPort = 25;
    private static final String[] smtpHosts = new String[3];

    static {
	int i = 0;
	smtpHosts[i++] = "";
	smtpHosts[i++] = "";
	smtpHosts[i++] = "";
    }

    public void contextInitialized(ServletContextEvent sce) {
	int i;
	Email email = null;
	for (i = 0; i < smtpHosts.length; ++i) {
	    StringBuffer msg = new StringBuffer(1024);
	    msg.append("Trying email -- " + smtpHosts[i]);
	    try {
		Socket sock = new Socket(smtpHosts[i], smtpPort);
		sock.close();
		email = new Email(smtpHosts[i]);
		msg.append(" -- ok");
		System.err.println(msg);
		break;
	    }
	    catch (IOException err) {
		//err.printStackTrace();
		msg.append(" -- cannot connect");
		System.err.println(msg);
	    }
	    catch (SecurityException err) {
		//err.printStackTrace();
		msg.append(" -- cannot connect");
		System.err.println(msg);
	    }
	}
	if (email == null) {
	    System.err.println("EmailManager: " +
			       "Cannot connect to smtp server " +
			       "[provide correct params]");
	}
	else {
	    sce.getServletContext().setAttribute("email", email);
	    System.err.println("EmailManager: init ok");
	}
    }
    
    public void contextDestroyed(ServletContextEvent sce) {
	Object email = sce.getServletContext().getAttribute("email");
	if (email != null && email instanceof Email) {
	    sce.getServletContext().removeAttribute("email");
	    System.err.println("EmailManager: destroy ok");
	}
    }

};
