// -*- Java -*-

// MessageBean.java (13.5.2003)

package drdcal;

import java.lang.*;
import java.io.*;

import java.util.*;
import java.sql.*;

public class MessageBean {

    int id;
    UserInfo fromUser;
    java.util.Date posted;
    String message;

    public MessageBean() {
	id = 0;
	fromUser = new UserInfo();
	posted = new java.util.Date();
	message = "";
    }

    public synchronized int getId() { return id; }
    public synchronized void setId(int aId) { id = aId; }

    public synchronized UserInfo getFromUser() { return fromUser; }
    public synchronized void setFromUser(UserInfo aUser) { fromUser = aUser; }

    public synchronized java.util.Date getPosted() { return posted; }
    public synchronized void setPosted(java.util.Date aDate) {
	posted = aDate; }

    public synchronized String getMessage() { return message; }
    public synchronized void setMessage(String aMsg) { message = aMsg; }

    public synchronized String toString() {
	return "MessageBean [" +
	    " id: " + id +
	    ", fromUser: " + fromUser +
	    ", posted: " + posted +
	    ", message: " + message +
	    " ]";
    }

    public synchronized void saveToDb(Connection con) throws SQLException {
	if (id == 0) { // insert
	    insert(con);
	}
	else { // update
	    update(con);
	}
    }

    private synchronized void insert(Connection con) throws SQLException {
	String query = "INSERT INTO message VALUES " +
	    "(NULL, ?, FROM_UNIXTIME(?), ?)";
	PreparedStatement sql = con.prepareStatement(query);
	sql.setInt(1, fromUser.getId());
	sql.setLong(2, posted.getTime() / 1000);
	sql.setString(3, message);
	sql.execute();
	ResultSet res = sql.executeQuery("SELECT LAST_INSERT_ID()");
	res.first();
	id = res.getInt(1);
    }

    private synchronized void update(Connection con) throws SQLException {
	String query = "UPDATE message SET message = ? WHERE id = ?";
	PreparedStatement sql = con.prepareStatement(query);
	sql.setString(1, message);
	sql.setInt(2, id);
	sql.execute();
    }

    public synchronized static Collection getAllMessages(Connection con)
	throws SQLException {
	String query = "SELECT userinfo.username AS user, " +
	    "DATE_FORMAT(message.t_posted, \"%e.%c. %k:%i \") AS posted, " +
	    "message.message AS msg " +
	    "FROM message, userinfo " +
	    "WHERE message.from_user = userinfo.id " +
	    "ORDER BY t_posted DESC";
	Statement sql = con.createStatement();
	ResultSet res = sql.executeQuery(query);
	Collection msgs = new ArrayList();
	while (res.next()) {
	    Map msg = new Hashtable();
	    msg.put("user", res.getString("user"));
	    msg.put("posted", res.getString("posted"));
	    msg.put("msg", res.getString("msg"));
	    msgs.add(msg);
	}
	return msgs;
    }

    public synchronized static void removeAllMessages(Connection con)
	throws SQLException {
	String query = "DELETE FROM message";
	Statement sql = con.createStatement();
	sql.executeUpdate(query);
    }
};
